"use strict";
/* tslint:disable */
/* eslint-disable */
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var runtime_1 = require("./runtime");
var apis = require("./apis");
var runtime = require("./runtime");
var VERSION = "1.3.0";
var API_VERSION = "2025-05-08";
var Autoenhance = /** @class */ (function () {
    function Autoenhance(apiKey, options) {
        if (options === void 0) { options = {}; }
        // In previous SDKs this method was called uploadImageS3, so we have this
        // alias as backwards compatibility.
        // 
        this.uploadImageS3 = this.uploadImage;
        var _a = options.baseURL, baseURL = _a === void 0 ? 'https://api.autoenhance.ai' : _a;
        this.configuration = new runtime_1.Configuration({
            basePath: baseURL,
            middleware: [],
            apiKey: function () { return apiKey; },
            headers: {
                'x-api-version': API_VERSION
            }
        });
        this._BracketsApi = new apis.BracketsApi(this.configuration);
        this.injectApiMethods(this._BracketsApi);
        this._ImagesApi = new apis.ImagesApi(this.configuration);
        this.injectApiMethods(this._ImagesApi);
        this._OrdersApi = new apis.OrdersApi(this.configuration);
        this.injectApiMethods(this._OrdersApi);
    }
    Autoenhance.prototype.injectApiMethods = function (apiInstance) {
        var methodNames = Object.getOwnPropertyNames(Object.getPrototypeOf(apiInstance))
            .filter(function (name) { return typeof apiInstance[name] === 'function' && name !== 'constructor'; });
        for (var _i = 0, methodNames_1 = methodNames; _i < methodNames_1.length; _i++) {
            var methodName = methodNames_1[_i];
            // Bind each method to the API instance and add it to this Client
            this[methodName] = apiInstance[methodName].bind(apiInstance);
        }
    };
    Object.defineProperty(Autoenhance.prototype, "BracketsApi", {
        // Older clients needed to construct a reference to the class which
        // handled communication with a certain collection of endpoints, we 
        // handle backwards compatibility here.
        //
        get: function () {
            return this._BracketsApi;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Autoenhance.prototype, "ImagesApi", {
        get: function () {
            return this._ImagesApi;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Autoenhance.prototype, "OrdersApi", {
        get: function () {
            return this._OrdersApi;
        },
        enumerable: false,
        configurable: true
    });
    Autoenhance.prototype.downloadEnhancedImageURL = function (requestParameters) {
        if (requestParameters['id'] == null) {
            throw new runtime.RequiredError('id', 'Required parameter "id" was null or undefined when calling downloadEnhancedImageURL().');
        }
        var queryParameters = {};
        if (requestParameters['quality'] != null) {
            queryParameters['quality'] = requestParameters['quality'];
        }
        if (requestParameters['format'] != null) {
            queryParameters['format'] = requestParameters['format'];
        }
        if (requestParameters['preview'] != null) {
            queryParameters['preview'] = requestParameters['preview'];
        }
        if (requestParameters['watermark'] != null) {
            queryParameters['watermark'] = requestParameters['watermark'];
        }
        if (requestParameters['maxWidth'] != null) {
            queryParameters['max_width'] = requestParameters['maxWidth'];
        }
        if (requestParameters['scale'] != null) {
            queryParameters['scale'] = requestParameters['scale'];
        }
        return "{{this.configuration.basePath}/v3/images/{id}/enhanced".replace("{".concat("id", "}"), encodeURIComponent(String(requestParameters['id'])));
    };
    Autoenhance.prototype.downloadOriginalImageURL = function (requestParameters) {
        if (requestParameters['id'] == null) {
            throw new runtime.RequiredError('id', 'Required parameter "id" was null or undefined when calling downloadOriginalImageURL().');
        }
        var queryParameters = {};
        if (requestParameters['quality'] != null) {
            queryParameters['quality'] = requestParameters['quality'];
        }
        if (requestParameters['format'] != null) {
            queryParameters['format'] = requestParameters['format'];
        }
        if (requestParameters['preview'] != null) {
            queryParameters['preview'] = requestParameters['preview'];
        }
        if (requestParameters['watermark'] != null) {
            queryParameters['watermark'] = requestParameters['watermark'];
        }
        if (requestParameters['maxWidth'] != null) {
            queryParameters['max_width'] = requestParameters['maxWidth'];
        }
        if (requestParameters['scale'] != null) {
            queryParameters['scale'] = requestParameters['scale'];
        }
        return "".concat(this.configuration.basePath, "/v3/images/").concat(encodeURIComponent(String(requestParameters['id'])), "/original");
    };
    Autoenhance.prototype.uploadImage = function (imageProperties, image) {
        return __awaiter(this, void 0, void 0, function () {
            var s3PutObjectUrl;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.createImage({
                            imageIn: __assign(__assign({}, imageProperties), { contentType: "image/jpeg" }),
                        })];
                    case 1:
                        s3PutObjectUrl = (_a.sent()).s3PutObjectUrl;
                        if (!s3PutObjectUrl) return [3 /*break*/, 3];
                        return [4 /*yield*/, fetch(s3PutObjectUrl, {
                                method: "PUT",
                                headers: {
                                    "Content-Type": "image/jpeg",
                                },
                                body: image,
                            })];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    return Autoenhance;
}());
exports.default = Autoenhance;
