/**
 * Autoenhance API
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: v3
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import type { ImageCreatedOutFinetuneSettings } from './ImageCreatedOutFinetuneSettings';
/**
 *
 * @export
 * @interface ImageCreatedOut
 */
export interface ImageCreatedOut {
    [key: string]: any | any;
    /**
     * The version of the AI model to use for enhancing the image. Versions ending in an .x will use the latest minor version as soon as it's published.
     * @type {string}
     * @memberof ImageCreatedOut
     */
    aiVersion?: ImageCreatedOutAiVersionEnum;
    /**
     * The type of clouds in the new sky to replace the original sky with. Options include: CLEAR, LOW_CLOUD, HIGH_CLOUD
     * @type {string}
     * @memberof ImageCreatedOut
     */
    cloudType?: ImageCreatedOutCloudTypeEnum | null;
    /**
     * The date the image was registered with Autoenhance.
     * @type {number}
     * @memberof ImageCreatedOut
     */
    dateAdded?: number;
    /**
     * Whether image has been already downloaded and paid for.
     * @type {boolean}
     * @memberof ImageCreatedOut
     */
    downloaded?: boolean;
    /**
     * Whether to enhance the image.
     * @type {boolean}
     * @memberof ImageCreatedOut
     */
    enhance?: boolean;
    /**
     * The type of enhancement to apply to the image. PROPERTY or PROPERTY_USA is used with AI version < 4.0, for >= 4.0 use WARM or NEUTRAL..
     * @type {string}
     * @memberof ImageCreatedOut
     */
    enhanceType?: ImageCreatedOutEnhanceTypeEnum;
    /**
     *
     * @type {ImageCreatedOutFinetuneSettings}
     * @memberof ImageCreatedOut
     */
    finetuneSettings?: ImageCreatedOutFinetuneSettings;
    /**
     *
     * @type {string}
     * @memberof ImageCreatedOut
     */
    imageId?: string;
    /**
     *
     * @type {string}
     * @memberof ImageCreatedOut
     */
    imageName?: string;
    /**
     * Correct any lens distortion in the image.
     * @type {boolean}
     * @memberof ImageCreatedOut
     */
    lensCorrection?: boolean;
    /**
     * Metadata for the image.
     * @type {{ [key: string]: any; }}
     * @memberof ImageCreatedOut
     */
    metadata?: {
        [key: string]: any;
    };
    /**
     *
     * @type {any}
     * @memberof ImageCreatedOut
     */
    readonly orderId?: any | null;
    /**
     * Whether to blur any faces or license plates in the image.
     * @type {boolean}
     * @memberof ImageCreatedOut
     */
    privacy?: boolean | null;
    /**
     * A rating between 0 and 5 on how good the image enhancmeent. Higher is better.
     * @type {number}
     * @memberof ImageCreatedOut
     */
    rating?: number;
    /**
     * The detected scene of the image i.e garden, patio, kitchen, etc.
     * @type {string}
     * @memberof ImageCreatedOut
     */
    scene?: string;
    /**
     * Whether the sky replacement feature was enabled for the image.
     * @type {boolean}
     * @memberof ImageCreatedOut
     */
    skyReplacement?: boolean;
    /**
     * The status of the order.
     * @type {any}
     * @memberof ImageCreatedOut
     */
    readonly status?: any | null;
    /**
     * Reason for the image's current status
     * @type {any}
     * @memberof ImageCreatedOut
     */
    readonly statusReason?: any | null;
    /**
     * The upload URL for the image to be uploaded to.
     * @type {any}
     * @memberof ImageCreatedOut
     */
    readonly uploadUrl?: any | null;
    /**
     * Whether to upscale the image.
     * @type {boolean}
     * @memberof ImageCreatedOut
     */
    upscale?: boolean;
    /**
     * The user ID of the user who uploaded (owns) the image.
     * @type {any}
     * @memberof ImageCreatedOut
     */
    readonly userId?: any | null;
    /**
     * Whether the vertical correction feature was enabled for the image.
     * @type {boolean}
     * @memberof ImageCreatedOut
     */
    verticalCorrection?: boolean;
    /**
     * Whether to pull the windows in the image (used with AI version >= 4.0).
     * @type {boolean}
     * @memberof ImageCreatedOut
     */
    windowPull?: boolean | null;
}
/**
 * @export
 */
export declare const ImageCreatedOutAiVersionEnum: {
    readonly Dev: "dev";
    readonly _5X: "5.x";
    readonly _50: "5.0";
    readonly _4X: "4.x";
    readonly _47: "4.7";
    readonly _45: "4.5";
    readonly _44: "4.4";
    readonly _43: "4.3";
    readonly _42: "4.2";
    readonly _41: "4.1";
    readonly _40: "4.0";
    readonly _3X: "3.x";
    readonly _35: "3.5";
    readonly _34: "3.4";
    readonly _33: "3.3";
    readonly _32: "3.2";
    readonly _31: "3.1";
    readonly _30: "3.0";
};
export type ImageCreatedOutAiVersionEnum = typeof ImageCreatedOutAiVersionEnum[keyof typeof ImageCreatedOutAiVersionEnum];
/**
 * @export
 */
export declare const ImageCreatedOutCloudTypeEnum: {
    readonly Clear: "CLEAR";
    readonly LowCloud: "LOW_CLOUD";
    readonly HighCloud: "HIGH_CLOUD";
};
export type ImageCreatedOutCloudTypeEnum = typeof ImageCreatedOutCloudTypeEnum[keyof typeof ImageCreatedOutCloudTypeEnum];
/**
 * @export
 */
export declare const ImageCreatedOutEnhanceTypeEnum: {
    readonly Property: "property";
    readonly PropertyUsa: "property_usa";
    readonly Warm: "warm";
    readonly Neutral: "neutral";
    readonly Modern: "modern";
};
export type ImageCreatedOutEnhanceTypeEnum = typeof ImageCreatedOutEnhanceTypeEnum[keyof typeof ImageCreatedOutEnhanceTypeEnum];
/**
 * Check if a given object implements the ImageCreatedOut interface.
 */
export declare function instanceOfImageCreatedOut(value: object): value is ImageCreatedOut;
export declare function ImageCreatedOutFromJSON(json: any): ImageCreatedOut;
export declare function ImageCreatedOutFromJSONTyped(json: any, ignoreDiscriminator: boolean): ImageCreatedOut;
export declare function ImageCreatedOutToJSON(json: any): ImageCreatedOut;
export declare function ImageCreatedOutToJSONTyped(value?: Omit<ImageCreatedOut, 'order_id' | 'status' | 'status_reason' | 'upload_url' | 'user_id'> | null, ignoreDiscriminator?: boolean): any;
