/**
 * Autoenhance API
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: v3
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import type { ImageCreatedOutFinetuneSettings } from './ImageCreatedOutFinetuneSettings';
/**
 *
 * @export
 * @interface ImageIn
 */
export interface ImageIn {
    [key: string]: any | any;
    /**
     * The version of the AI model to use for enhancing the image. Versions ending in an .x will use the latest minor version as soon as it's published.
     * @type {string}
     * @memberof ImageIn
     */
    aiVersion?: ImageInAiVersionEnum;
    /**
     * The type of clouds in the new sky to replace the original sky with. Options include: CLEAR, LOW_CLOUD, HIGH_CLOUD
     * @type {string}
     * @memberof ImageIn
     */
    cloudType?: ImageInCloudTypeEnum | null;
    /**
     * Whether to enhance the image.
     * @type {boolean}
     * @memberof ImageIn
     */
    enhance?: boolean;
    /**
     * The type of enhancement to apply to the image. PROPERTY or PROPERTY_USA is used with AI version < 4.0, for >= 4.0 use WARM or NEUTRAL..
     * @type {string}
     * @memberof ImageIn
     */
    enhanceType?: ImageInEnhanceTypeEnum;
    /**
     *
     * @type {ImageCreatedOutFinetuneSettings}
     * @memberof ImageIn
     */
    finetuneSettings?: ImageCreatedOutFinetuneSettings;
    /**
     *
     * @type {string}
     * @memberof ImageIn
     */
    imageName: string;
    /**
     * Correct any lens distortion in the image.
     * @type {boolean}
     * @memberof ImageIn
     */
    lensCorrection?: boolean;
    /**
     * Metadata for the image.
     * @type {{ [key: string]: any; }}
     * @memberof ImageIn
     */
    metadata?: {
        [key: string]: any;
    };
    /**
     *
     * @type {string}
     * @memberof ImageIn
     */
    orderId?: string;
    /**
     * Whether to blur any faces or license plates in the image.
     * @type {boolean}
     * @memberof ImageIn
     */
    privacy?: boolean | null;
    /**
     * A rating between 0 and 5 on how good the image enhancmeent. Higher is better.
     * @type {number}
     * @memberof ImageIn
     */
    rating?: number;
    /**
     * Enable the replacement of the original sky for a summer sky.
     * @type {boolean}
     * @memberof ImageIn
     */
    skyReplacement?: boolean;
    /**
     * Whether the image is a 360 image.
     * @type {boolean}
     * @memberof ImageIn
     */
    threesixty?: boolean;
    /**
     * Whether to upscale the image.
     * @type {boolean}
     * @memberof ImageIn
     */
    upscale?: boolean;
    /**
     * Correct any vertical distortion in the image so that it appears straight.
     * @type {boolean}
     * @memberof ImageIn
     */
    verticalCorrection?: boolean;
    /**
     * Whether to pull the windows in the image (used with AI version >= 4.0).
     * @type {boolean}
     * @memberof ImageIn
     */
    windowPull?: boolean | null;
}
/**
 * @export
 */
export declare const ImageInAiVersionEnum: {
    readonly Dev: "dev";
    readonly _5X: "5.x";
    readonly _50: "5.0";
    readonly _4X: "4.x";
    readonly _47: "4.7";
    readonly _45: "4.5";
    readonly _44: "4.4";
    readonly _43: "4.3";
    readonly _42: "4.2";
    readonly _41: "4.1";
    readonly _40: "4.0";
    readonly _3X: "3.x";
    readonly _35: "3.5";
    readonly _34: "3.4";
    readonly _33: "3.3";
    readonly _32: "3.2";
    readonly _31: "3.1";
    readonly _30: "3.0";
};
export type ImageInAiVersionEnum = typeof ImageInAiVersionEnum[keyof typeof ImageInAiVersionEnum];
/**
 * @export
 */
export declare const ImageInCloudTypeEnum: {
    readonly Clear: "CLEAR";
    readonly LowCloud: "LOW_CLOUD";
    readonly HighCloud: "HIGH_CLOUD";
};
export type ImageInCloudTypeEnum = typeof ImageInCloudTypeEnum[keyof typeof ImageInCloudTypeEnum];
/**
 * @export
 */
export declare const ImageInEnhanceTypeEnum: {
    readonly Property: "property";
    readonly PropertyUsa: "property_usa";
    readonly Warm: "warm";
    readonly Neutral: "neutral";
    readonly Modern: "modern";
};
export type ImageInEnhanceTypeEnum = typeof ImageInEnhanceTypeEnum[keyof typeof ImageInEnhanceTypeEnum];
/**
 * Check if a given object implements the ImageIn interface.
 */
export declare function instanceOfImageIn(value: object): value is ImageIn;
export declare function ImageInFromJSON(json: any): ImageIn;
export declare function ImageInFromJSONTyped(json: any, ignoreDiscriminator: boolean): ImageIn;
export declare function ImageInToJSON(json: any): ImageIn;
export declare function ImageInToJSONTyped(value?: ImageIn | null, ignoreDiscriminator?: boolean): any;
