/**
 * Autoenhance API
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: v3
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import type { OrderImageIn } from './OrderImageIn';
/**
 *
 * @export
 * @interface OrderHDRProcessIn
 */
export interface OrderHDRProcessIn {
    /**
     * The version of the AI model to use for enhancing the image. Versions ending in an .x will use the latest minor version as soon as it's published.
     * @type {string}
     * @memberof OrderHDRProcessIn
     */
    aiVersion?: OrderHDRProcessInAiVersionEnum;
    /**
     * The type of clouds in the new sky to replace the original sky with. Options include: CLEAR, LOW_CLOUD, HIGH_CLOUD
     * @type {string}
     * @memberof OrderHDRProcessIn
     */
    cloudType?: OrderHDRProcessInCloudTypeEnum | null;
    /**
     * Whether to enhance the image.
     * @type {boolean}
     * @memberof OrderHDRProcessIn
     */
    enhance?: boolean;
    /**
     * The type of enhancement to apply to the image. PROPERTY or PROPERTY_USA is used with AI version < 4.0, for >= 4.0 use WARM or NEUTRAL..
     * @type {string}
     * @memberof OrderHDRProcessIn
     */
    enhanceType?: OrderHDRProcessInEnhanceTypeEnum;
    /**
     *
     * @type {Array<OrderImageIn>}
     * @memberof OrderHDRProcessIn
     */
    images?: Array<OrderImageIn>;
    /**
     * Correct any lens distortion in the image.
     * @type {boolean}
     * @memberof OrderHDRProcessIn
     */
    lensCorrection?: boolean;
    /**
     * If provided then group into an image after every specified number of brackets, if  not provided or set to 0 then we automatically group based on visual analysis.
     * @type {number}
     * @memberof OrderHDRProcessIn
     */
    numberOfBracketsPerImage?: number;
    /**
     * Whether to blur any faces or license plates in the image.
     * @type {boolean}
     * @memberof OrderHDRProcessIn
     */
    privacy?: boolean | null;
    /**
     * Enable the replacement of the original sky for a summer sky.
     * @type {boolean}
     * @memberof OrderHDRProcessIn
     */
    skyReplacement?: boolean;
    /**
     * Whether to upscale the image.
     * @type {boolean}
     * @memberof OrderHDRProcessIn
     */
    upscale?: boolean;
    /**
     * Correct any vertical distortion in the image so that it appears straight.
     * @type {boolean}
     * @memberof OrderHDRProcessIn
     */
    verticalCorrection?: boolean;
    /**
     * Whether to pull the windows in the image (used with AI version >= 4.0).
     * @type {boolean}
     * @memberof OrderHDRProcessIn
     */
    windowPull?: boolean | null;
}
/**
 * @export
 */
export declare const OrderHDRProcessInAiVersionEnum: {
    readonly Dev: "dev";
    readonly _5X: "5.x";
    readonly _50: "5.0";
    readonly _4X: "4.x";
    readonly _47: "4.7";
    readonly _45: "4.5";
    readonly _44: "4.4";
    readonly _43: "4.3";
    readonly _42: "4.2";
    readonly _41: "4.1";
    readonly _40: "4.0";
    readonly _3X: "3.x";
    readonly _35: "3.5";
    readonly _34: "3.4";
    readonly _33: "3.3";
    readonly _32: "3.2";
    readonly _31: "3.1";
    readonly _30: "3.0";
};
export type OrderHDRProcessInAiVersionEnum = typeof OrderHDRProcessInAiVersionEnum[keyof typeof OrderHDRProcessInAiVersionEnum];
/**
 * @export
 */
export declare const OrderHDRProcessInCloudTypeEnum: {
    readonly Clear: "CLEAR";
    readonly LowCloud: "LOW_CLOUD";
    readonly HighCloud: "HIGH_CLOUD";
};
export type OrderHDRProcessInCloudTypeEnum = typeof OrderHDRProcessInCloudTypeEnum[keyof typeof OrderHDRProcessInCloudTypeEnum];
/**
 * @export
 */
export declare const OrderHDRProcessInEnhanceTypeEnum: {
    readonly Property: "property";
    readonly PropertyUsa: "property_usa";
    readonly Warm: "warm";
    readonly Neutral: "neutral";
    readonly Modern: "modern";
};
export type OrderHDRProcessInEnhanceTypeEnum = typeof OrderHDRProcessInEnhanceTypeEnum[keyof typeof OrderHDRProcessInEnhanceTypeEnum];
/**
 * Check if a given object implements the OrderHDRProcessIn interface.
 */
export declare function instanceOfOrderHDRProcessIn(value: object): value is OrderHDRProcessIn;
export declare function OrderHDRProcessInFromJSON(json: any): OrderHDRProcessIn;
export declare function OrderHDRProcessInFromJSONTyped(json: any, ignoreDiscriminator: boolean): OrderHDRProcessIn;
export declare function OrderHDRProcessInToJSON(json: any): OrderHDRProcessIn;
export declare function OrderHDRProcessInToJSONTyped(value?: OrderHDRProcessIn | null, ignoreDiscriminator?: boolean): any;
