/* tslint:disable */
/* eslint-disable */
/**
 * Autoenhance API
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: v3
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { mapValues } from '../runtime';
import type { ImageCreatedOutFinetuneSettings } from './ImageCreatedOutFinetuneSettings';
import {
    ImageCreatedOutFinetuneSettingsFromJSON,
    ImageCreatedOutFinetuneSettingsFromJSONTyped,
    ImageCreatedOutFinetuneSettingsToJSON,
    ImageCreatedOutFinetuneSettingsToJSONTyped,
} from './ImageCreatedOutFinetuneSettings';

/**
 * 
 * @export
 * @interface ImageCreatedOut
 */
export interface ImageCreatedOut {
    [key: string]: any | any;
    /**
     * The version of the AI model to use for enhancing the image. Versions ending in an .x will use the latest minor version as soon as it's published.
     * @type {string}
     * @memberof ImageCreatedOut
     */
    aiVersion?: ImageCreatedOutAiVersionEnum;
    /**
     * The type of clouds in the new sky to replace the original sky with. Options include: CLEAR, LOW_CLOUD, HIGH_CLOUD
     * @type {string}
     * @memberof ImageCreatedOut
     */
    cloudType?: ImageCreatedOutCloudTypeEnum | null;
    /**
     * The date the image was registered with Autoenhance.
     * @type {number}
     * @memberof ImageCreatedOut
     */
    dateAdded?: number;
    /**
     * Whether image has been already downloaded and paid for.
     * @type {boolean}
     * @memberof ImageCreatedOut
     */
    downloaded?: boolean;
    /**
     * Whether to enhance the image.
     * @type {boolean}
     * @memberof ImageCreatedOut
     */
    enhance?: boolean;
    /**
     * The type of enhancement to apply to the image. PROPERTY or PROPERTY_USA is used with AI version < 4.0, for >= 4.0 use WARM or NEUTRAL..
     * @type {string}
     * @memberof ImageCreatedOut
     */
    enhanceType?: ImageCreatedOutEnhanceTypeEnum;
    /**
     * 
     * @type {ImageCreatedOutFinetuneSettings}
     * @memberof ImageCreatedOut
     */
    finetuneSettings?: ImageCreatedOutFinetuneSettings;
    /**
     * 
     * @type {string}
     * @memberof ImageCreatedOut
     */
    imageId?: string;
    /**
     * 
     * @type {string}
     * @memberof ImageCreatedOut
     */
    imageName?: string;
    /**
     * Correct any lens distortion in the image.
     * @type {boolean}
     * @memberof ImageCreatedOut
     */
    lensCorrection?: boolean;
    /**
     * Metadata for the image.
     * @type {{ [key: string]: any; }}
     * @memberof ImageCreatedOut
     */
    metadata?: { [key: string]: any; };
    /**
     * 
     * @type {any}
     * @memberof ImageCreatedOut
     */
    readonly orderId?: any | null;
    /**
     * Whether to blur any faces or license plates in the image.
     * @type {boolean}
     * @memberof ImageCreatedOut
     */
    privacy?: boolean | null;
    /**
     * A rating between 0 and 5 on how good the image enhancmeent. Higher is better.
     * @type {number}
     * @memberof ImageCreatedOut
     */
    rating?: number;
    /**
     * The detected scene of the image i.e garden, patio, kitchen, etc.
     * @type {string}
     * @memberof ImageCreatedOut
     */
    scene?: string;
    /**
     * Whether the sky replacement feature was enabled for the image.
     * @type {boolean}
     * @memberof ImageCreatedOut
     */
    skyReplacement?: boolean;
    /**
     * The status of the order.
     * @type {any}
     * @memberof ImageCreatedOut
     */
    readonly status?: any | null;
    /**
     * Reason for the image's current status
     * @type {any}
     * @memberof ImageCreatedOut
     */
    readonly statusReason?: any | null;
    /**
     * The upload URL for the image to be uploaded to.
     * @type {any}
     * @memberof ImageCreatedOut
     */
    readonly uploadUrl?: any | null;
    /**
     * Whether to upscale the image.
     * @type {boolean}
     * @memberof ImageCreatedOut
     */
    upscale?: boolean;
    /**
     * The user ID of the user who uploaded (owns) the image.
     * @type {any}
     * @memberof ImageCreatedOut
     */
    readonly userId?: any | null;
    /**
     * Whether the vertical correction feature was enabled for the image.
     * @type {boolean}
     * @memberof ImageCreatedOut
     */
    verticalCorrection?: boolean;
    /**
     * Whether to pull the windows in the image (used with AI version >= 4.0).
     * @type {boolean}
     * @memberof ImageCreatedOut
     */
    windowPull?: boolean | null;
}


/**
 * @export
 */
export const ImageCreatedOutAiVersionEnum = {
    Dev: 'dev',
    _5X: '5.x',
    _50: '5.0',
    _4X: '4.x',
    _47: '4.7',
    _45: '4.5',
    _44: '4.4',
    _43: '4.3',
    _42: '4.2',
    _41: '4.1',
    _40: '4.0',
    _3X: '3.x',
    _35: '3.5',
    _34: '3.4',
    _33: '3.3',
    _32: '3.2',
    _31: '3.1',
    _30: '3.0'
} as const;
export type ImageCreatedOutAiVersionEnum = typeof ImageCreatedOutAiVersionEnum[keyof typeof ImageCreatedOutAiVersionEnum];

/**
 * @export
 */
export const ImageCreatedOutCloudTypeEnum = {
    Clear: 'CLEAR',
    LowCloud: 'LOW_CLOUD',
    HighCloud: 'HIGH_CLOUD'
} as const;
export type ImageCreatedOutCloudTypeEnum = typeof ImageCreatedOutCloudTypeEnum[keyof typeof ImageCreatedOutCloudTypeEnum];

/**
 * @export
 */
export const ImageCreatedOutEnhanceTypeEnum = {
    Property: 'property',
    PropertyUsa: 'property_usa',
    Warm: 'warm',
    Neutral: 'neutral',
    Modern: 'modern'
} as const;
export type ImageCreatedOutEnhanceTypeEnum = typeof ImageCreatedOutEnhanceTypeEnum[keyof typeof ImageCreatedOutEnhanceTypeEnum];


/**
 * Check if a given object implements the ImageCreatedOut interface.
 */
export function instanceOfImageCreatedOut(value: object): value is ImageCreatedOut {
    return true;
}

export function ImageCreatedOutFromJSON(json: any): ImageCreatedOut {
    return ImageCreatedOutFromJSONTyped(json, false);
}

export function ImageCreatedOutFromJSONTyped(json: any, ignoreDiscriminator: boolean): ImageCreatedOut {
    if (json == null) {
        return json;
    }
    return {
        
            ...json,
        'aiVersion': json['ai_version'] == null ? undefined : json['ai_version'],
        'cloudType': json['cloud_type'] == null ? undefined : json['cloud_type'],
        'dateAdded': json['date_added'] == null ? undefined : json['date_added'],
        'downloaded': json['downloaded'] == null ? undefined : json['downloaded'],
        'enhance': json['enhance'] == null ? undefined : json['enhance'],
        'enhanceType': json['enhance_type'] == null ? undefined : json['enhance_type'],
        'finetuneSettings': json['finetune_settings'] == null ? undefined : ImageCreatedOutFinetuneSettingsFromJSON(json['finetune_settings']),
        'imageId': json['image_id'] == null ? undefined : json['image_id'],
        'imageName': json['image_name'] == null ? undefined : json['image_name'],
        'lensCorrection': json['lens_correction'] == null ? undefined : json['lens_correction'],
        'metadata': json['metadata'] == null ? undefined : json['metadata'],
        'orderId': json['order_id'] == null ? undefined : json['order_id'],
        'privacy': json['privacy'] == null ? undefined : json['privacy'],
        'rating': json['rating'] == null ? undefined : json['rating'],
        'scene': json['scene'] == null ? undefined : json['scene'],
        'skyReplacement': json['sky_replacement'] == null ? undefined : json['sky_replacement'],
        'status': json['status'] == null ? undefined : json['status'],
        'statusReason': json['status_reason'] == null ? undefined : json['status_reason'],
        'uploadUrl': json['upload_url'] == null ? undefined : json['upload_url'],
        'upscale': json['upscale'] == null ? undefined : json['upscale'],
        'userId': json['user_id'] == null ? undefined : json['user_id'],
        'verticalCorrection': json['vertical_correction'] == null ? undefined : json['vertical_correction'],
        'windowPull': json['window_pull'] == null ? undefined : json['window_pull'],
    };
}

export function ImageCreatedOutToJSON(json: any): ImageCreatedOut {
    return ImageCreatedOutToJSONTyped(json, false);
}

export function ImageCreatedOutToJSONTyped(value?: Omit<ImageCreatedOut, 'order_id'|'status'|'status_reason'|'upload_url'|'user_id'> | null, ignoreDiscriminator: boolean = false): any {
    if (value == null) {
        return value;
    }

    return {
        
            ...value,
        'ai_version': value['aiVersion'],
        'cloud_type': value['cloudType'],
        'date_added': value['dateAdded'],
        'downloaded': value['downloaded'],
        'enhance': value['enhance'],
        'enhance_type': value['enhanceType'],
        'finetune_settings': ImageCreatedOutFinetuneSettingsToJSON(value['finetuneSettings']),
        'image_id': value['imageId'],
        'image_name': value['imageName'],
        'lens_correction': value['lensCorrection'],
        'metadata': value['metadata'],
        'privacy': value['privacy'],
        'rating': value['rating'],
        'scene': value['scene'],
        'sky_replacement': value['skyReplacement'],
        'upscale': value['upscale'],
        'vertical_correction': value['verticalCorrection'],
        'window_pull': value['windowPull'],
    };
}

