/* tslint:disable */
/* eslint-disable */
/**
 * Autoenhance API
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: v3
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { mapValues } from '../runtime';
import type { ImageCreatedOutFinetuneSettings } from './ImageCreatedOutFinetuneSettings';
import {
    ImageCreatedOutFinetuneSettingsFromJSON,
    ImageCreatedOutFinetuneSettingsFromJSONTyped,
    ImageCreatedOutFinetuneSettingsToJSON,
    ImageCreatedOutFinetuneSettingsToJSONTyped,
} from './ImageCreatedOutFinetuneSettings';

/**
 * 
 * @export
 * @interface ImageInUpdate
 */
export interface ImageInUpdate {
    [key: string]: any | any;
    /**
     * The version of the AI model to use for enhancing the image. Versions ending in an .x will use the latest minor version as soon as it's published.
     * @type {string}
     * @memberof ImageInUpdate
     */
    aiVersion?: ImageInUpdateAiVersionEnum;
    /**
     * The type of clouds in the new sky to replace the original sky with. Options include: CLEAR, LOW_CLOUD, HIGH_CLOUD
     * @type {string}
     * @memberof ImageInUpdate
     */
    cloudType?: ImageInUpdateCloudTypeEnum | null;
    /**
     * Whether to enhance the image.
     * @type {boolean}
     * @memberof ImageInUpdate
     */
    enhance?: boolean;
    /**
     * The type of enhancement to apply to the image. PROPERTY or PROPERTY_USA is used with AI version < 4.0, for >= 4.0 use WARM or NEUTRAL..
     * @type {string}
     * @memberof ImageInUpdate
     */
    enhanceType?: ImageInUpdateEnhanceTypeEnum;
    /**
     * 
     * @type {ImageCreatedOutFinetuneSettings}
     * @memberof ImageInUpdate
     */
    finetuneSettings?: ImageCreatedOutFinetuneSettings;
    /**
     * 
     * @type {string}
     * @memberof ImageInUpdate
     */
    imageName?: string;
    /**
     * Correct any lens distortion in the image.
     * @type {boolean}
     * @memberof ImageInUpdate
     */
    lensCorrection?: boolean;
    /**
     * Metadata for the image.
     * @type {{ [key: string]: any; }}
     * @memberof ImageInUpdate
     */
    metadata?: { [key: string]: any; };
    /**
     * 
     * @type {string}
     * @memberof ImageInUpdate
     */
    orderId?: string;
    /**
     * Whether to blur any faces or license plates in the image.
     * @type {boolean}
     * @memberof ImageInUpdate
     */
    privacy?: boolean | null;
    /**
     * A rating between 0 and 5 on how good the image enhancmeent. Higher is better.
     * @type {number}
     * @memberof ImageInUpdate
     */
    rating?: number;
    /**
     * Enable the replacement of the original sky for a summer sky.
     * @type {boolean}
     * @memberof ImageInUpdate
     */
    skyReplacement?: boolean;
    /**
     * Whether the image is a 360 image.
     * @type {boolean}
     * @memberof ImageInUpdate
     */
    threesixty?: boolean;
    /**
     * Whether to upscale the image.
     * @type {boolean}
     * @memberof ImageInUpdate
     */
    upscale?: boolean;
    /**
     * Correct any vertical distortion in the image so that it appears straight.
     * @type {boolean}
     * @memberof ImageInUpdate
     */
    verticalCorrection?: boolean;
    /**
     * Whether to pull the windows in the image (used with AI version >= 4.0).
     * @type {boolean}
     * @memberof ImageInUpdate
     */
    windowPull?: boolean | null;
}


/**
 * @export
 */
export const ImageInUpdateAiVersionEnum = {
    Dev: 'dev',
    _5X: '5.x',
    _50: '5.0',
    _4X: '4.x',
    _47: '4.7',
    _45: '4.5',
    _44: '4.4',
    _43: '4.3',
    _42: '4.2',
    _41: '4.1',
    _40: '4.0',
    _3X: '3.x',
    _35: '3.5',
    _34: '3.4',
    _33: '3.3',
    _32: '3.2',
    _31: '3.1',
    _30: '3.0'
} as const;
export type ImageInUpdateAiVersionEnum = typeof ImageInUpdateAiVersionEnum[keyof typeof ImageInUpdateAiVersionEnum];

/**
 * @export
 */
export const ImageInUpdateCloudTypeEnum = {
    Clear: 'CLEAR',
    LowCloud: 'LOW_CLOUD',
    HighCloud: 'HIGH_CLOUD'
} as const;
export type ImageInUpdateCloudTypeEnum = typeof ImageInUpdateCloudTypeEnum[keyof typeof ImageInUpdateCloudTypeEnum];

/**
 * @export
 */
export const ImageInUpdateEnhanceTypeEnum = {
    Property: 'property',
    PropertyUsa: 'property_usa',
    Warm: 'warm',
    Neutral: 'neutral',
    Modern: 'modern'
} as const;
export type ImageInUpdateEnhanceTypeEnum = typeof ImageInUpdateEnhanceTypeEnum[keyof typeof ImageInUpdateEnhanceTypeEnum];


/**
 * Check if a given object implements the ImageInUpdate interface.
 */
export function instanceOfImageInUpdate(value: object): value is ImageInUpdate {
    return true;
}

export function ImageInUpdateFromJSON(json: any): ImageInUpdate {
    return ImageInUpdateFromJSONTyped(json, false);
}

export function ImageInUpdateFromJSONTyped(json: any, ignoreDiscriminator: boolean): ImageInUpdate {
    if (json == null) {
        return json;
    }
    return {
        
            ...json,
        'aiVersion': json['ai_version'] == null ? undefined : json['ai_version'],
        'cloudType': json['cloud_type'] == null ? undefined : json['cloud_type'],
        'enhance': json['enhance'] == null ? undefined : json['enhance'],
        'enhanceType': json['enhance_type'] == null ? undefined : json['enhance_type'],
        'finetuneSettings': json['finetune_settings'] == null ? undefined : ImageCreatedOutFinetuneSettingsFromJSON(json['finetune_settings']),
        'imageName': json['image_name'] == null ? undefined : json['image_name'],
        'lensCorrection': json['lens_correction'] == null ? undefined : json['lens_correction'],
        'metadata': json['metadata'] == null ? undefined : json['metadata'],
        'orderId': json['order_id'] == null ? undefined : json['order_id'],
        'privacy': json['privacy'] == null ? undefined : json['privacy'],
        'rating': json['rating'] == null ? undefined : json['rating'],
        'skyReplacement': json['sky_replacement'] == null ? undefined : json['sky_replacement'],
        'threesixty': json['threesixty'] == null ? undefined : json['threesixty'],
        'upscale': json['upscale'] == null ? undefined : json['upscale'],
        'verticalCorrection': json['vertical_correction'] == null ? undefined : json['vertical_correction'],
        'windowPull': json['window_pull'] == null ? undefined : json['window_pull'],
    };
}

export function ImageInUpdateToJSON(json: any): ImageInUpdate {
    return ImageInUpdateToJSONTyped(json, false);
}

export function ImageInUpdateToJSONTyped(value?: ImageInUpdate | null, ignoreDiscriminator: boolean = false): any {
    if (value == null) {
        return value;
    }

    return {
        
            ...value,
        'ai_version': value['aiVersion'],
        'cloud_type': value['cloudType'],
        'enhance': value['enhance'],
        'enhance_type': value['enhanceType'],
        'finetune_settings': ImageCreatedOutFinetuneSettingsToJSON(value['finetuneSettings']),
        'image_name': value['imageName'],
        'lens_correction': value['lensCorrection'],
        'metadata': value['metadata'],
        'order_id': value['orderId'],
        'privacy': value['privacy'],
        'rating': value['rating'],
        'sky_replacement': value['skyReplacement'],
        'threesixty': value['threesixty'],
        'upscale': value['upscale'],
        'vertical_correction': value['verticalCorrection'],
        'window_pull': value['windowPull'],
    };
}

